#define OBJECTS_CC
#include "defs.hh"

#include "objects.hh"

// reserved: X, S, I, Y, 0-9

const struct ObjectDesc AsciiObjects[] =
{
  //  0
  { 'y', 0x0,0xC }, // bunby heri - the annoying thing in Cutman level beginning
                    // [1] 6E (palette 1)
  { 'm', 0x0,0x8 }, // metto
                    // [5] 6A (palette 1)
  { 'j', 0x8,0x8 }, // red jumping junk (Flea)
                    // [2] 7E (palette 1)
  { 'f', 0x8,0xC }, // floor trap/landmine (Spine/Gabyoall)
                    // [5] 72 (palette 2)
  //  4
  { 'c', 0x8,0x8 }, // vertically moving eyecube (suzy)
                    // [1] 6E (palette 2)
  { 'v', 0x8,0x0 }, // spread cannon in floor
                    // [4-5] 7A,7E (palette 2)
  { 0 },   // SPECIAL, SEE BELOW
  { 'i', 0x0,0x0 }, // sinewave flying penguin
                    // [4] 76 (blackwhite-palette)
  //  8
  { 's', 0xF,0x0 }, // sinewave flying bomb
                    // [4] 62 (palette 2)
  { 't', 0x0,0xC }, // jumping telephone post (Big Eye) (bomb damage only 4)
                    // [2-3] C2,C6 (palette 1)
  { 'u', 0x8,0x0 }, // hamburger
                    // [5] 72 (palette 2)
  { '<', 0x8,0x8 }, // singleshot cannon pointing left (timing 1)
                    // [4] 62 (palette 2)
  //  C
  { '-', 0x0,0x8 }, // elec arc
                    // [4] 66 (palette 1)
  { 'B', 0x8,0x0 }, // periodical bombing (y = 0xE0) (not destroyable)
                    // [1] BA (palette 2)
  { 0 },   // SPECIAL, SEE BELOW
  { 'I', 0x8,0x0 }, // flying fire, take two! (not destroyable)
                    // [1] 7A (palette 1) (appears behind walls!)
  // 10
  { 0 },   // SPECIAL, SEE BELOW
  { 0 },
  { 'G', 0x0,0x4 }, // green guardian (Xl=0, Yl=4)
                    // [1-3] 96,9A,9E (palette 1)
  { 'L', 0x0,0xC }, // shooting lift ("foot holder") (not destroyable)
                    // [2-3] B6,BA (palette 2)
  // 14
  { 'R', 0x0,0x4 }, // robots that may lose their head
                    // [1-3] A2,A6,AA (palette 1)
  { 'a', 0x0,0x4 }, // axe throwing robot in Gutsman
                    // UNKNOWN GFX
  { '.', 0x8,0x0 }, // spread cannon pointing down
                    // [4-5] 7A,7E (palette 2)
  { '>', 0x8,0x8 }, // singleshot cannon pointing right
                    // [4] 62 (palette 2)
  // 18
  { ']', 0x4,0x6 }, // fire torch to the right (Fireman)
                    // [4] C6 (palette 1) (incomplete?)
  { '', 0x0,0x7 }, // electricity decoration 1 (Elecman level only)
                    // [4] 66 (palette blackwhite)
  { 0 }, // bullet sound? (not destroyable)
  { 0 }, //small explosion (from object $0D but also from enemy killed) (not destroyable)
  // 1C
  { 'r', 0x0,0x4 }, // scissor machine
  { 0 }, //instantiated at $B222, $BC73
  { 0 }, //instantiated at $BD1F
  { 0 }, //instantiated at $B752
  // 20
  { 0 },
  { 'h', 0x8,0x8 }, // horizontally moving eyecube (suzy)
                    // [1] 6E (palette 2)
  { '{', 0x8,0x8 }, // singleshot cannon pointing left (timing 2)
                    // [4] 62 (palette 2)
  { '}', 0x8,0x8 }, // singleshot cannon pointing up
                    // [4] 62 (palette 2)
  // 24
  { '=', 0x0,0x8 }, // elec arc, different timing
                    // [4] 66 (palette blackwhite)
  { '', 0x0,0x7 }, // electricity decoration 2 (Elecman level only)
                    // [4] 66 (palette blackwhite)
  { 0 },
  { 0 }, // buzzblocks (Elecman stage)
  // 28
  { 0 }, //instantiated at $AF19
  { 0 }, //instantiated at $B218, $B762, also referenced at C6C6 (I think)
  { 0 }, //instantiated at $AD6A
  { 0 },
  // 2C
  { 0 },   // SPECIAL, SEE BELOW
  { 0 }, //bullet sound? instantiated at $E7F8
  { 0 },
  { 0 },   // SPECIAL, SEE BELOW
  // 30
  { 0 },   // SPECIAL, SEE BELOW
  { 'd', 0x0,0x0 }, // periodically three fire devils from lava to sky
  { 0 },   // SPECIAL, SEE BELOW
  { 0 },  // scissor weapon
  // 34
  { 0 },  // ice weapon
  { 0 },  // bomb weapon
  { 0 },  // fire weapon
  { 0 },  // fire shield weapon
  // 38
  { 0 }, // Boss6's pieces
  { 0 },
  { 0 },   // wily3 boss
  { 'T', 0x4,0xC }, // teleport when a "boss" killed, activate enemy if not dead.
  // 3C
  { 'o', 0x8,0x9 }, // score ball = bonus pearl
                    // (palette 2)
  { 'p', 0x8,0xC }, // small weapon
  { 'e', 0x8,0x9 }, // small energy
  { 'P', 0x8,0x8 }, // big weapon
  // 40 
  { 'E', 0x8,0x8 }, // big energy
  { 'U', 0x8,0x8 }, // 1up
  { 'M', 0x8,0x8 }, // magnet beam
                    // [3] 96 (palette Megaman)
  { 'O', 0x8,0x0 }, // teleport immediately (invisible)
  // 44
  { '*', 0x8,0x8 }, // end level
                    // (palette 1)
  { 'W', 0x8,0x8 }, // all weapons full (yashichi)
                    // [5] 72 (palette 1)
  { 0 },
  { 0 },
  // 48
  { 0 },
  { '', 0x8,0x8 }, // random powerup (enemy destruction)
  { 0 }, //? used at 0001CB5B
  
  /*
            [1] 8A = unknown
            
            [2] 92,96 = watchers (92=watcher, 96=electricity) (palette 1)
  
  */
};

/*
     Controllers:
     
     0x06 functions:
             10,FF = this room has "watchers" (The flying beamers in Elecman and Wily4)
     0x0E functions:
             D0,04 = falling fire (Fireman level)
             B0,FF = zigzag fire (Fireman level)
     0x10 functions:
             E0,80 = activate buzzblocks (Iceman) - used twice
             10,80 = activate buzzblocks (Elecman)
     0x2C functions:
             10,FF = unknown (Wily4, screen 2) - also instantiated by 0001DA9A
     0x2F functions:
             80,80 = super scrolling start (Wily3)
             FC,80 = unknown (Gutsman, screen 1)
             58,80 = unknown (Gutsman, screen 4)
     0x30 functions:
             80,80 = super scrolling stop (Wily3)
             F8,80 = launch lift (Gutsman, screen 0)
             80,FF = stop lift (Gutsman, screen 0)
             60,80 = unknown (Gutsman, screen 5)
     0x32 functions:
             80,E0 = lava activator (Fireman) (??)
     0xFF functions:
             E0,0C = increase pace (wily3)
             01,08 = unknown (Gutsman, screen 5)
             40,0A = unknown (Gutsman, screen 5)
             10,04 = unknown (Gutsman, screen 6)
             50,06 = unknown (Gutsman, screen 6)
             80,02 = water start (Iceman)
             00,00 = water end   (Iceman)
 */

const unsigned NumAsciiObjects = sizeof(AsciiObjects) / sizeof(*AsciiObjects);
